<?php declare(strict_types=1);

namespace Plugin\css_uploadFormular\Migrations;

use JTL\Helpers\Text;
use JTL\Plugin\PluginInterface;
use JTL\Shop;
use JTL\Mail\Mail\Mail;
use JTL\Mail\Mailer;


use JTL\Plugin\Migration;
use JTL\Update\IMigration;

/**
 * Class Migration20210429123301
 * @package Plugin\jtl_test\Migrations
 */
class Migration20210429123301 extends Migration implements IMigration   {
    /**
     * @inheritdoc
     */

    public function copyTable($sourceDB,$destinationDB="", $copyTable=true,$deleteSourceDB=false) {
        error_log('starte copy '.$sourceDB);
        $result = $this->getDB()->query("SHOW TABLES LIKE '".$sourceDB."'",2);
        if($copyTable && $result !== null && is_array($result) && count($result)) {
            error_log('DB Vorhanden '.$sourceDB);
            $result = $this->getDB()->query("SELECT * FROM ".$sourceDB." WHERE 1",2);
            foreach($result as $oItem) {
                error_log('schreibe Datensatz nach '.$destinationDB);
                $this->getDB()->insert($destinationDB,$oItem);
            }
        }
        if($deleteSourceDB) {
            $this->execute("DROP TABLE IF EXISTS ".$sourceDB,3);
        }
    }


    /*
    define('JTLLOG_LEVEL_EMERGENCY', 600);
    define('JTLLOG_LEVEL_ALERT', 550);
    define('JTLLOG_LEVEL_CRITICAL', 500);
    define('JTLLOG_LEVEL_ERROR', 400);
    define('JTLLOG_LEVEL_WARNING', 300);
    define('JTLLOG_LEVEL_NOTICE', 250);
    define('JTLLOG_LEVEL_INFO', 200);
    define('JTLLOG_LEVEL_DEBUG', 100);
*/

    public function JTLWriteLog($cLog='',$nLevel=JTLLOG_LEVEL_INFO ,$bForce=false) {
        if (\mb_strlen($cLog) > 0 && ($bForce || \Jtllog::getSytemlogFlag(false))) {
            $logger = Shop::Container()->getLogService();
            $logger = $logger->withName("css_uploadFormularConfig");
            $logger->log($nLevel, $cLog, ["css_uploadFormularConfig"]);
            return true;
        }
        return false;
    }


    public function up()    {
        $this->execute("
              CREATE TABLE IF NOT EXISTS `css_uploadFormularConfig` (
                  `version` varchar(255) NOT NULL DEFAULT '2.0.0',
                  `sqlupdate` int(10) NOT NULL DEFAULT '0',
                  `pluginActive` char(1) NOT NULL default 'N',
                  `framework` char(3) NOT NULL default 'B4',
                  `css` text NOT NULL,
                  `js` text NOT NULL,
								  `uploadPosition` char(1) NOT NULL DEFAULT 'B',
								  `adminMail` varchar(250) NOT NULL DEFAULT '',
								  `maxUploads` int(3) NOT NULL DEFAULT 3,
								  `maxBytes` int(10) NOT NULL DEFAULT 100,
								  `uploadTypes` varchar(250) NOT NULL DEFAULT 'csv,txt,pdf,doc,docx,xls,xlsx,jpeg,jpg,gif,png',
								  `buttonSelector` varchar(250) NOT NULL DEFAULT '.info-essential',
								  `buttonPosition` varchar(250) NOT NULL DEFAULT 'off',
								  `cAnrede` char(1) NOT NULL DEFAULT 'O',
								  `cEmail` char(1) NOT NULL DEFAULT 'P',
								  `cName` char(1) NOT NULL DEFAULT 'P',
								  `cInformation` char(1) NOT NULL DEFAULT 'O',
								  `cTextfeld1` char(1) NOT NULL DEFAULT 'N',
								  `cTextfeld2` char(1) NOT NULL DEFAULT 'N',
								  `cTextfeld3` char(1) NOT NULL DEFAULT 'N',
								  `cTextfeld4` char(1) NOT NULL DEFAULT 'N',
								  `DSGVO` char(1) NOT NULL DEFAULT 'Y',
								  `useCaptcha` char(1) NOT NULL DEFAULT 'Y',
								  `cAnredeField` varchar(60) NOT NULL DEFAULT 'N',
								  `cEmailField` varchar(60) NOT NULL DEFAULT 'N',
								  `cNameField` varchar(60) NOT NULL DEFAULT 'N',
								  `cInformationField` varchar(60) NOT NULL DEFAULT 'N',
								  `cTextfeld1Field` varchar(60) NOT NULL DEFAULT 'N',
								  `cTextfeld2Field` varchar(60) NOT NULL DEFAULT 'N',
								  `cTextfeld3Field` varchar(60) NOT NULL DEFAULT 'N',
								  `cTextfeld4Field` varchar(60) NOT NULL DEFAULT 'N',
								  `needFileSubject` char(1) NOT NULL DEFAULT 'Y',
								  `ButtonTextColor` varchar(10) NOT NULL DEFAULT '',
								  `ButtonTextColorHover` varchar(10) NOT NULL DEFAULT '',
								  `ButtonColor` varchar(10) NOT NULL DEFAULT '',
								  `ButtonColorHover` varchar(10) NOT NULL DEFAULT '',
								  `ButtonStyles` text NOT NULL,
								  `needFileUpload` varchar(1) NOT NULL DEFAULT 'O'
                ) ENGINE=InnoDB COLLATE utf8_unicode_ci
        ");


        $this->copyTable("css_uploadFormular_konfig","css_uploadFormularConfig",true,false);


        $result = $this->getDB()->query(
            'SELECT * from `css_uploadFormularConfig` where 1',
            2
        );

        if($result === null || count($result) < 1) {
           $this->execute(
            "INSERT INTO `css_uploadFormularConfig` (`version`) VALUES ('2.0.0')"
            );
        } else {
            $this->execute("UPDATE css_uploadFormularConfig set `version` = '2.0.0' ");
        }
    }

    /**
     * @inheritdoc
     */
    public function down() {
    }
}
