<?php declare(strict_types=1);

namespace Plugin\css_uploadFormular\Migrations;

use JTL\Plugin\Migration;
use JTL\Update\IMigration;
use JTL\Shop;

class Migration20240416123301 extends Migration implements IMigration {

	public function columnExist($table, $field) {
		// false bedeutet das es die Spalte nicht gibt
		return $this->getDB()->query("Show columns from `" . $table . "` like '" . $field . "' ", 1);
	}

	public function tableExist($table) {
		// in Rows steht die Anzahl der Zeilen, false bedeutet das es die Tabelle nicht gibt
		$obj =  $this->getDB()->query("SHOW TABLE STATUS  like '" . $table . "'", 1);
		if($obj && (int) $obj->Rows == 0) {
			$o = $this->getDB()->query("SELECT COUNT(*) AS anzahl FROM " . $table . " WHERE 1",1);
			$obj->Rows = (int) $o->anzahl;
			return $obj;
		}
		return $obj;
	}


	public function up() {

		$this->execute(
			"
				ALTER TABLE `css_uploadFormularConfig` CHANGE `version` `version` VARCHAR(10)
      ");

		$this->execute(
			"
				ALTER TABLE `css_uploadFormularConfig` CHANGE `framework` `framework` CHAR(20)
      ");
		$this->execute(
			"
				ALTER TABLE `css_uploadFormularConfig` CHANGE `buttonPosition` `buttonPosition` VARCHAR(20)
      ");



		if(($obj = $this->tableExist('css_uploadFormularConfig')) && $obj->Rows > 0) {
			$this->execute("UPDATE css_uploadFormularConfig set `version` = '2.5.5' ");
		} else {
			$this->execute(
				"INSERT INTO `css_uploadFormularConfig` (`version`) VALUES ('2.5.5')"
			);
		}


	}

	/**
	 * @inheritdoc
	 */
	public function down() {
		if ($this->doDeleteData()) {
		}
	}
}
