(function () {
    'use strict';

    var cssUploadFormularClass = function (options) {
        this.init(options);
    };

    cssUploadFormularClass.VERSION = '1.1.0';
    cssUploadFormularClass.DEFAULTS = {
        plugin: 'css_uploadFormular',
        showDebug : false,
        needFileSubject: 'Y',
        maxUploader: 3,
        delete_upload_content:'Sind Sie sicher das Sie diese Datei l&ouml;schen m&ouml;chten?',
        delete_upload_title:'L&ouml;schen einer Datei',
        confirm_cancel: 'Nein ich m&ouml;chte nicht',
        confirm_yes: 'Ja ich m&ouml;chte',
        modal_close: 'schlie&szlig;en',
        confirmTemplate: '\
				<div class="modal fade" id="confirmation_modal_css_uploadFormular" role="dialog" style="display: none;">\
		    	<div class="modal-dialog">\
		    				<div class="modal-content">\
		    			<div class="modal-header">\
		    				<h4 class="modal-title"></h4>\
		    			</div>\
  			<div class="modal-body">\
				</div>\
		    			<form role="form" method="post" action="category_delete" id="delete_data">\
		    				<div class="modal-footer">\
		    					<button type="button" class="btn btn-danger confirmYes" ></button>\
		    					<button type="button" class="btn btn-primary confirmNo" data-dismiss="modal"></button>\
		    				</div>\
		    			</form>\
		    		</div>\
		    	</div>\
		    </div>\
		',
        noticeTemplate: '\
				<div class="modal fade " id="modal_css_uploadFormular" role="dialog" style="display: none;">\
		    	<div class="modal-dialog">\
		    				<div class="modal-content">\
		    			<div class="modal-header">\
		    				<h4 class="modal-title"></h4>\
		    			</div>\
  			<div class="modal-body">\
				</div>\
		    				<div class="modal-footer">\
		    					<button type="button" class="btn btn-default noticeClose" data-dismiss="modal"></button>\
		    				</div>\
		    		</div>\
		    	</div>\
		    </div>\
		'
    };
    cssUploadFormularClass.prototype = {

        constructor: cssUploadFormularClass,

        init: function (options) {
            this.options = $.extend({}, cssUploadFormularClass.DEFAULTS, options);
            var that = this;
            this.debug("Starte das UploadFormular Plugin");
            this.initUploadDelete();
            this.initUploadDownload();
            this.initUpload();
            this.initSubmit();
        },

        register: function(options) {
            var that=this;
            this.debug("Starte register");
        },

        debug: function(s) {
            if(this.options.showDebug) {
                console.log(s);
            }
        },

        initUpload: function() {
            var that=this;

            $(document).on("click", ".uploader .upload-filename", function() {
                $(this).closest(".uploader").find("button.file-upload").trigger("click");
            });
            if(that.options.needFileSubject=='N') {
                $(this).closest(".uploader").find("button.file-upload").attr("disabled",false);
                return;
            }
            $(document).on("keyup blur", "input[name='file_subject']",function() {
                if($(this).val().length > 3 && $(this).val().trim()!='') {
                    that.debug("field has event and is filled");
                    $(this).closest(".uploader").find("button.file-upload").attr("disabled",false);
                    $(this).closest(".uploader").find(".upload-filename").attr("disabled",false);
                } else {
                    $(this).closest(".uploader").find("button.file-upload").attr("disabled",true);
                    $(this).closest(".uploader").find(".upload-filename").attr("disabled",true);
                    that.debug("field has event and is not filled");
                }
            });
        },

        initSubmit: function () {
            var that = this;

            $(document).on("click","#css-upload-submit",function(e) {
                console.log("darf ich senden?");
                if(!$("#css_uploadForm").data('reCaptchaConfirmed')) {
                    console.log("Google Abfrage");
                    $("#css_uploadForm").submit();
                } else {
                    $("#css_uploadForm").submit();
                }
            });
            $(document).on("submit","#css_uploadForm",function(e) {
                if($(this).data('reCaptchaConfirmed') || $(this).data('recaptchaconfirmed')) {
                    e.preventDefault();
                    e.stopPropagation();
                    $("#css_uploadForm .has-error").removeClass("has-error");
                    $("#css_uploadForm .text-error").slideUp('slow', function () {
                        $(this).remove();
                    });
                    $(".uploader .text-error").slideUp('slow', function () {
                        $(this).remove();
                    });
                    var data = $("#css_uploadForm").serialize();
                    that.post_data("io.php", "io=css_uploadFormular&" + data);
                    return false;
                }
            });

        },

        initUploadDownload: function() {
            var that=this;
            $(document).on("click", ".uploader .file-download",function() {
                if($(this).data("id")!='') {
                    $(this).attr("href","io.php?io=css_uploadFormular&action=download&file="+ $(this).data("id"))
                }
            });
        },

        initUploadDelete: function() {
            var that=this;
            $(document).on("click", "button.file-delete",function(e) {
                if(!$(this).hasClass('confirmed')) {
                    console.log("is clicked");
                    e.preventDefault();
                    e.stopPropagation();
                    that.openModalConfirmation(
                        this,
                        'modal-upload-delete-confirm',
                        that.options.delete_upload_title,
                        that.options.delete_upload_content,
                        that.options.confirm_yes,
                        that.options.confirm_cancel
                    );
                    return false;
                }
                that.post_data("io.php", "io=css_uploadFormular&action=delete&file="+ $(this).data("id"));
                if($(".uploader").length<=3 && $(".uploader:last").find("input[name='filename']").val()!='') {
                    var obj = $(addionalUploadObj).clone();
                    $(obj).find("label").html("");
                    $(obj).find(".uploader").attr(UploadFormIdNames + UploaderCounter);
                    $(fileUploadBox).append(obj);
                    createUploader();
                }

            });
        },

        openModalConfirmation: function (el, selector, titel,content,confirmYes,confirmNo) {
            var that = this;
            $("#confirmation_modal_"+ that.options.plugin).remove();
            $("body").append(that.options.confirmTemplate);
            $("#confirmation_modal_"+ that.options.plugin +" .modal-content").addClass(selector);
            $("#confirmation_modal_"+ that.options.plugin +" .modal-title").html(titel);
            $("#confirmation_modal_"+ that.options.plugin +" .modal-body").html(content);
            $("#confirmation_modal_"+ that.options.plugin +" .confirmYes").html(confirmYes);
            $("#confirmation_modal_"+ that.options.plugin +" .confirmNo").html(confirmNo);
            $("#confirmation_modal_"+ that.options.plugin +" .confirmYes").on("click", function() {
                $(el).addClass("confirmed").trigger("click").removeClass("confirmed");
                $("#confirmation_modal_"+ that.options.plugin).modal("hide");
            });
            $("#confirmation_modal_"+ that.options.plugin).modal("show");
        },


        openModalNotice: function (selector, titel,content) {
            $("#modal_"+ this.options.plugin).remove();
            $("body").append(this.options.noticeTemplate);
            if(selector) $("#modal_"+ this.plugin +" .modal-content").addClass(selector);
            $("#modal_"+ this.options.plugin +" .modal-title").html(titel);
            $("#modal_"+ this.options.plugin +" .modal-body").html(content);
            $("#modal_"+ this.options.plugin +" .noticeClose").html(this.options.modal_close);
            $("#modal_"+ this.options.plugin).modal("show");
        },

        post_data: function (url, data) {
            var that = this;
            jQuery.ajax({
                type: 'POST',
                url: url,
                data: data,
                showNoSuggestionNotice: true,
                dataType: 'json',
                beforeSend: function(jqXHR) {
                    jqXHR.overrideMimeType('text/json;charset=iso-8859-1');
                },
                success: function(data,responseText,jqXHR) {
                    if( jqXHR.status == 204 ) {
                        that.debug('sorry, here is nothing to do for me. (Token problem?)')
                        return false;
                    }
                    if( jqXHR.status == 404 ) {
                        that.debug('sorry, here is nothing to show you.')
                        return false;
                    }
                    if( jqXHR.status == 403 ) {
                        that.debug('sorry, this is no place for you.')
                        return false;
                    }
                    console.log(data);
                    //debug(data);
                    if( data.script )	{
                        eval(data.script);
                    }
                    $("body").trigger('contentChanged');
                },
                error: function() {
                    that.debug('something is wrong....anything buggy?');
                },
                complete: function() {

                }
            });
        },
    };

    $.css_uploadFormular = function(options) {
        $.cssUploadFormular = new cssUploadFormularClass(options);
        $.cssUploadFormular.register();
        return $.cssUploadFormular;
    };
})(jQuery);

$(document).ready(function () {
});
